package org.bitbucket.bradleysmithllc.etlunit.feature;

import org.bitbucket.bradleysmithllc.etlunit.ClassDirector;
import org.bitbucket.bradleysmithllc.etlunit.PatternClassDirector;
import org.bitbucket.bradleysmithllc.etlunit.SuiteClassDirectorImpl;
import org.bitbucket.bradleysmithllc.etlunit.parser.specification.ParseException;
import org.bitbucket.bradleysmithllc.etlunit.parser.specification.TestSpecificationParser;
import org.bitbucket.bradleysmithllc.etlunit.regexp.SuiteNameExpression;
import org.bitbucket.bradleysmithllc.etlunit.regexp.SuiteNamesExpression;
import org.bitbucket.bradleysmithllc.etlunit.regexp.TestExpression;

public class UserDirectedClassDirectorFeature extends AbstractFeature
{
	private final String instanceName;

	private final ClassDirector classDirector;

	public UserDirectedClassDirectorFeature(String instanceName, String desc) throws ParseException {
		// use the parser
		classDirector = TestSpecificationParser.parse(desc);

		this.instanceName = instanceName;
	}

	@Override
	public String getFeatureName()
	{
		return "user-class-director_" + instanceName;
	}

	@Override
	public ClassDirector getDirector()
	{
		return classDirector;
	}

	@Override
	public long getPriorityLevel()
	{
		return -1L;
	}
}
