package org.bitbucket.bradleysmithllc.etlunit.io;

import org.apache.commons.exec.ExecuteStreamHandler;

import java.io.*;
import java.util.concurrent.CountDownLatch;

public class ModifiedPumpRedirectHandler implements ExecuteStreamHandler
{
	private final CustomPumpStreamHandler pumpStreamHandler;

	private final CountDownLatch streamAcquiredLatch = new CountDownLatch(3);

	public ModifiedPumpRedirectHandler(OutputStream output) throws IOException
	{
		pumpStreamHandler = new CustomPumpStreamHandler(output);
	}

	public InputStream getProcessOutputStream()
	{
		throw new UnsupportedOperationException();
	}

	public OutputStream getProcessInputStream()
	{
		throw new UnsupportedOperationException();
	}

	public Writer getProcessInput()
	{
		throw new UnsupportedOperationException();
	}

	public Reader getProcessOutput()
	{
		throw new UnsupportedOperationException();
	}

	public void setProcessOutputStream(InputStream is)
	{
		pumpStreamHandler.setProcessOutputStream(is);
		streamAcquiredLatch.countDown();
	}

	public void stop()
	{
		pumpStreamHandler.stop();
	}

	public void start()
	{
		pumpStreamHandler.start();
	}

	public void setProcessInputStream(OutputStream os) throws IOException
	{
		pumpStreamHandler.setProcessInputStream(os);
		streamAcquiredLatch.countDown();
	}

	public void setProcessErrorStream(InputStream is)
	{
		pumpStreamHandler.setProcessErrorStream(is);
		streamAcquiredLatch.countDown();
	}

	public void waitForStreams()
	{
		try {
			streamAcquiredLatch.await();
		} catch (InterruptedException e) {
			throw new RuntimeException("Why did this happen?", e);
		}
	}

	public void waitForOutputStreamToComplete() throws IOException {
		pumpStreamHandler.waitForOutput();
	}
}